package com.officetetsu.puzzle;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;

public class Lanking extends Activity
implements
View.OnClickListener,
DialogInterface.OnClickListener{

	private Score score;
	private TextView scoreBoard;
	private Button button_del, button_ret;
	private AlertDialog delete_dialog;


	/** Called when the activity is first created. */
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.score_board);

		button_del = (Button)findViewById(R.id.button1a);
		button_ret = (Button)findViewById(R.id.button2a);
		button_del.setOnClickListener(this);
		button_ret.setOnClickListener(this);

		score = new Score(this);
		scoreBoard = (TextView) findViewById(R.id.textView1a);
		scoreBoard.setText(readLanking());
	}

	private String readLanking(){
		try{
			StringBuffer stringBuffer = new StringBuffer();
			byte[] buffer = new byte[24];

			FileInputStream input = openFileInput("score.bin");
			int num = input.available() / 24;
			if(num > 10) num = 10;
			for(int i = 0; i < num; i++){
				for(int j = 0; j < 24; j++)
					buffer[j] = (byte)input.read();
				score.setBytes(buffer);
				if(score.turn < Integer.MAX_VALUE)
				stringBuffer.append(score.toString());
			}
			input.close();
			if(stringBuffer.length() == 0)
				return(getString(R.string.error_no_record));
			return(stringBuffer.toString());
		}
		catch (FileNotFoundException e){
			button_del.setEnabled(false);
			return(getString(R.string.error_no_record));
		}
		catch (IOException e){
			return(getString(R.string.error_io));
		}
	}

	@Override
	public void onClick(View arg0) {
		// TODO Auto-generated method stub
		if(arg0 == button_ret){
			finish();
		} else
		if(arg0 == button_del){
			delete_dialog = new AlertDialog.Builder(this)
			.setTitle(R.string.title_delete)
			.setMessage(R.string.message02)
			.setPositiveButton(R.string.btn_top_yes, this)
			.setNeutralButton(R.string.btn_top_cancel, null)
			//.setPositiveButton(android.R.string.yes, this)
			//.setNeutralButton(android.R.string.cancel, null)
			.show();
		}
	}

	@Override
	public void onClick(DialogInterface dialog, int which) {
		// TODO Auto-generated method stub
		if(dialog == delete_dialog){
			if(which == DialogInterface.BUTTON_POSITIVE){
				if(deleteFile("score.bin"))
					scoreBoard.setText(R.string.error_no_record);
				else
					scoreBoard.setText(R.string.error_io);
			}
			button_del.setEnabled(false);
		}
	}
}
