package com.officetetsu.puzzle;

import java.util.Calendar;

import android.content.Context;

public class Score {
	private Context myContext;
	public int turn;
	public int year;
	public int month;
	public int day;
	public int hour;
	public int minute;
	
	public Score(Context context){
		myContext = context;
		turn = Integer.MAX_VALUE;
	}
	
	private int bytesToInteger(byte[] buffer){
		return(
		(((int)buffer[0] << 24) & 0xff000000) |
		(((int)buffer[1] << 16) & 0x00ff0000) |
		(((int)buffer[2] <<  8) & 0x0000ff00) |
		( (int)buffer[3]      ) & 0x000000ff);
	}

	private void integerToBytes(int intger, byte[] buffer){
		buffer[0] = (byte)((intger >> 24) & 0xff);
		buffer[1] = (byte)((intger >> 16) & 0xff);
		buffer[2] = (byte)((intger >>  8) & 0xff);
		buffer[3] = (byte)(intger & 0xff);
	}

	public void setBytes(byte[] buffer){
		byte[] int_buffer = new byte[4];
		
		for(int i = 0; i < 4; i++) int_buffer[i] = buffer[i];
		turn = bytesToInteger(int_buffer);
		for(int i = 0; i < 4; i++) int_buffer[i] = buffer[i + 4];
		year = bytesToInteger(int_buffer);
		for(int i = 0; i < 4; i++) int_buffer[i] = buffer[i + 8];
		month = bytesToInteger(int_buffer);
		for(int i = 0; i < 4; i++) int_buffer[i] = buffer[i + 12];
		day = bytesToInteger(int_buffer);
		for(int i = 0; i < 4; i++) int_buffer[i] = buffer[i + 16];
		hour = bytesToInteger(int_buffer);
		for(int i = 0; i < 4; i++) int_buffer[i] = buffer[i + 20];
		minute = bytesToInteger(int_buffer);	
	}

	public void getBytes(byte[] buffer){
		byte[] int_buffer = new byte[4];

		integerToBytes(turn, int_buffer);
		for(int i = 0; i < 4; i++) buffer[i] = int_buffer[i];
		integerToBytes(year, int_buffer);
		for(int i = 0; i < 4; i++) buffer[i + 4] = int_buffer[i];
		integerToBytes(month, int_buffer);
		for(int i = 0; i < 4; i++) buffer[i + 8] = int_buffer[i];
		integerToBytes(day, int_buffer);
		for(int i = 0; i < 4; i++) buffer[i + 12] = int_buffer[i];
		integerToBytes(hour, int_buffer);
		for(int i = 0; i < 4; i++) buffer[i + 16] = int_buffer[i];
		integerToBytes(minute, int_buffer);
		for(int i = 0; i < 4; i++) buffer[i + 20] = int_buffer[i];
	}

	public void setDateTime(){
		Calendar calendar = Calendar.getInstance();
		year = calendar.get(Calendar.YEAR);
		month = calendar.get(Calendar.MONTH);
		day = calendar.get(Calendar.DAY_OF_MONTH);
		hour = calendar.get(Calendar.HOUR_OF_DAY);
		minute = calendar.get(Calendar.MINUTE);
	}
	
	public String toString(){
		return
		Integer.toString(turn) + 
		myContext.getResources().getText(R.string.unit_turn).toString() +
		"-" +
		Integer.toString(year) +
		myContext.getResources().getText(R.string.unit_year).toString() +
		Integer.toString(month + 1) +
		myContext.getResources().getText(R.string.unit_month).toString() +
		Integer.toString(day) +
		myContext.getResources().getText(R.string.unit_day).toString() +
		"-" +
		Integer.toString(hour) +
		myContext.getResources().getText(R.string.unit_hour).toString() +
		Integer.toString(minute) +
		myContext.getResources().getText(R.string.unit_minute).toString() +
		"\n";
	}
}
